package xyz.pixelatedw.finalbeta;

import java.lang.management.ManagementFactory;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.time.Duration;
import java.util.HashMap;

import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.Player;
import net.minecraft.item.ItemInstance;
import net.minecraft.item.ItemType;
import net.minecraft.recipe.RecipeRegistry;
import net.minecraft.tile.Tile;
import net.minecraft.tile.WoolTile;

public class WyHelper {
	
	private static final Minecraft INSTANCE;
	public static final String SPAWN_TIME_TAG = "SpawnTime";
	public static final String PLAY_TIME_TAG = "PlayTime";
	public static long playTime;
	

	// Look if they're allowed to hold all block and item data in fucking arrays
	// I am also allowed to abuse maps to extend the shitty metadata excuse
	// doors have ok ? I don't even care about the overhead at this point.
	public static final HashMap<Integer, Long> DOOR_UPDATES = new HashMap<>();
	public static final HashMap<Integer, Boolean> DOOR_STATES = new HashMap<>();

	static {
		INSTANCE = getInstance();
	}

	public static Minecraft getInstance() {
		if (INSTANCE != null) {
			return INSTANCE;
		} else {
			try {
				Field f = Minecraft.class.getDeclaredFields()[1];
				f.setAccessible(true);
				return (Minecraft) f.get(null);
			} catch (SecurityException | IllegalArgumentException | IllegalAccessException e) {
				e.printStackTrace();
			}
			return null;
		}
	}

	public static long getRealDaysPlayed() {
		long seconds = WyHelper.playTime / 20;
		return Duration.ofSeconds(seconds).toDays();
	}

	public static long getGameDaysPlayed() {
		long seconds = WyHelper.getInstance().level.getLevelTime() / 20;
		return Duration.ofSeconds(seconds).toMinutes() / 20;
	}
	
	public static boolean isDebug() {
		return ManagementFactory.getRuntimeMXBean().getInputArguments().toString().indexOf("-agentlib:jdwp") > 0;
	}

	public static float lerp(float delta, float start, float end) {
		return start + delta * (end - start);
	}

	public static float clamp(float val, float min, float max) {
		return val < min ? min : Math.min(val, max);
	}

	public static void registerWhiteWoolRecipe() {
		Method method = RecipeRegistry.class.getDeclaredMethods()[2];
		method.setAccessible(true);
		try {
			// Makes new recipes for all colored wools so they can be dyed back white using bone meal
			for (int colorId = 0; colorId < 16; ++colorId) {
				method.invoke(RecipeRegistry.getInstance(), new ItemInstance(Tile.WOOL, 1, 0), new Object[]{
						new ItemInstance(Tile.WOOL, 1, WoolTile.method_2(colorId)), new ItemInstance(ItemType.dyePowder, 1, 15)});
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	
	public static void cheatCommand(Player player) {
//		player.level.setLevelTime(0);
//		player.level.getProperties().setRaining(false);
//		player.level.getProperties().setRainTime(0);
//		player.level.getProperties().setThundering(false);
//		player.level.getProperties().setThunderTime(0);
	}
}
