package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import net.minecraft.container.Container;
import net.minecraft.inventory.CraftingInventory;
import xyz.pixelatedw.finalbeta.ModConfig;
import xyz.pixelatedw.finalbeta.WyHelper;

@Mixin(CraftingInventory.class)
public class CraftingInventoryMixin {

	private static boolean hasCustomRecipesRegistered = false;
	
	@Inject(method = "<init>", at = @At("TAIL"))
	public void init(Container container, int x, int y, CallbackInfo ci) {
		if (ModConfig.ENABLE_WHITE_WOOL_RECIPE.get() && !hasCustomRecipesRegistered) {
			WyHelper.registerWhiteWoolRecipe();
			hasCustomRecipesRegistered = true;
		}
	}
}
