package xyz.pixelatedw.finalbeta.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import net.minecraft.entity.LivingEntity;
import net.minecraft.entity.animal.Chicken;
import net.minecraft.entity.animal.Pig;
import net.minecraft.item.ItemType;
import xyz.pixelatedw.finalbeta.ModConfig;

@Mixin(LivingEntity.class)
public class LivingEntityMixin {

	@Inject(method = "setSize", at = @At("HEAD"), cancellable = true)
	public void setSize(float f, float f1, CallbackInfo ci) {
		LivingEntity entity = (LivingEntity) (Object) this;
		if (entity instanceof Chicken) {
			entity.width = 0.3F;
			entity.height = 0.7F;
			ci.cancel();
		}
	}

	@Inject(method = "dropLoot", at = @At("TAIL"))
	public void dropLoot(CallbackInfo ci) {
		if (ModConfig.FIX_SADDLES_NOT_DROPPING.get()) {
			LivingEntity entity = (LivingEntity) (Object) this;
			if (entity instanceof Pig && ((Pig) entity).isSaddled()) {
				entity.dropItem(ItemType.saddle.id, 1);
			}
		}
	}
}
